use cardinale_2009_data, clear

capture program drop RegEm
program define RegEm
   syntax varlist , name(string)

   gettoken depvar explvar : varlist

   * i.i.d. regression
   regress `depvar' `explvar'
   est store reg_`name'

   * clustered regression
   regress `depvar' `explvar', cluster(id)
   est store rcl_`name'

   * mixed model
   xtmixed `depvar' `explvar' || id: `explvar'
   est store mix_`name'

   * wait to see
   set more on
   more
   set more off

end

* (1) bivariate relations, as in the paper

* Fig. 4A
scatter logchl logn, m(none) mlab(id) mlabpos(0) name(Fig4a, replace)
RegEm logchl logncen , name(chl_nn)

* Fig. 4B
scatter ea1 logn, m(none) mlab(id) mlabpos(0) name(Fig4b, replace)
RegEm ea1 logncen logncen2, name(rich_nn)

* Fig. 4C
scatter logchl sa, m(none) mlab(id) mlabpos(0) name(Fig4c, replace)
RegEm logchl sa, name( chl_sa )

* Fig. 4D
scatter gpp logchl, m(none) mlab(id) mlabpos(0) name(Fig4d, replace)
RegEm gpp logchl, name( gpp_chll )

* (2) the multivariate models, equation by equation
RegEm sa logncen logncen2 sr , name( rich_n_sr )

RegEm logchl logncen sa , name( chl_n_sa )

RegEm gpp logchl logncen , name( gpp_chl_n )

* (3) instrumental variables regression in the latter part of the model
ivregress 2sls logchl logncen (sa = logncen logncen2 sr), cluster(id)
est store ivcl_chl
ivregress 2sls logchl logncen (sa = logncen logncen2 sr)
estat overid
estadd scalar J   = r(sargan)
estadd scalar J_p = r(p_sargan)
est store iv_chl

set more on
more
set more off

ivregress 2sls gpp logncen (logchl = logncen logncen2 sr), cluster(id)
est store ivcl_gpp
ivregress 2sls gpp logncen (logchl = logncen logncen2 sr)
estat overid
estadd scalar J   = r(sargan)
estadd scalar J_p = r(p_sargan)
est store iv_gpp

exit
